package com.iotechn.unimall.admin.api.cloud.impl;

import java.util.List;

import org.apache.ibatis.session.RowBounds;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.util.ExcelUtil;
import com.iotechn.unimall.data.mapper.AboutUsHxinfoMapper;
import com.iotechn.unimall.data.domain.AboutUsHxinfo;
import com.iotechn.unimall.admin.api.cloud.IAboutUsHxinfoService;
import com.iotechn.unimall.data.model.Page;
import java.util.Date;
import org.springframework.transaction.annotation.Transactional;

/**
 * 关于我们核心价值Service业务层处理
 * 
 * @author jlb
 * @date 2023-06-27
 */
@Service
public class AboutUsHxinfoServiceImpl implements IAboutUsHxinfoService{
	@Autowired
	private AboutUsHxinfoMapper aboutUsHxinfoMapper;
	
	@Override
	public Boolean add(AboutUsHxinfo aboutUsHxinfo) throws ServiceException {
		Date now = new Date();
		aboutUsHxinfo.setGmtCreate(now);
		aboutUsHxinfo.setGmtUpdate(now);
		return aboutUsHxinfoMapper.insert(aboutUsHxinfo)>0;
	}

	@Override
	public Page<AboutUsHxinfo> list(String title,String deputyTitle,String coverImage,String videoUrl,String classify,String content,String details,String language,String status,Date gmtCreate,Date gmtUpdate,Long deleteFlag,Long pid, Integer page, Integer limit)throws ServiceException {
		Wrapper<AboutUsHxinfo> wrapper = new EntityWrapper<AboutUsHxinfo>();
														if (!StringUtils.isEmpty(title)) {
					wrapper.eq("title", title);
				}
												if (!StringUtils.isEmpty(deputyTitle)) {
					wrapper.eq("deputy_title", deputyTitle);
				}
												if (!StringUtils.isEmpty(coverImage)) {
					wrapper.eq("cover_image", coverImage);
				}
												if (!StringUtils.isEmpty(videoUrl)) {
					wrapper.eq("video_url", videoUrl);
				}
												if (!StringUtils.isEmpty(classify)) {
					wrapper.eq("classify", classify);
				}
												if (!StringUtils.isEmpty(content)) {
					wrapper.eq("content", content);
				}
												if (!StringUtils.isEmpty(details)) {
					wrapper.eq("details", details);
				}
												if (!StringUtils.isEmpty(language)) {
					wrapper.eq("language", language);
				}
												if (!StringUtils.isEmpty(status)) {
					wrapper.eq("status", status);
				}
												if (!StringUtils.isEmpty(gmtCreate)) {
					wrapper.eq("gmt_create", gmtCreate);
				}
												if (!StringUtils.isEmpty(gmtUpdate)) {
					wrapper.eq("gmt_update", gmtUpdate);
				}
												if (!StringUtils.isEmpty(deleteFlag)) {
					wrapper.eq("delete_flag", deleteFlag);
				}
												if (!StringUtils.isEmpty(pid)) {
					wrapper.eq("pid", pid);
				}
							wrapper.eq("delete_flag", 0);
		List<AboutUsHxinfo> list = aboutUsHxinfoMapper.selectPage(new RowBounds((page - 1) * limit, limit), wrapper);
		Integer count = aboutUsHxinfoMapper.selectCount(wrapper);
		return new Page<AboutUsHxinfo>(list, page, limit, count);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public Boolean delete(String id) {
		String[] ids = String.valueOf(id).split(",");
		for (String tt:ids) {
			AboutUsHxinfo tmp =  aboutUsHxinfoMapper.selectById(Long.parseLong(tt));
			if(tmp != null){
				tmp.setDeleteFlag(1l);
				aboutUsHxinfoMapper.updateById(tmp);
			}
		}
		return true;
	}

	@Override
	public Boolean update(AboutUsHxinfo aboutUsHxinfo) throws ServiceException {
		Date now = new Date();
		aboutUsHxinfo.setGmtUpdate(now);
		return aboutUsHxinfoMapper.updateById(aboutUsHxinfo)>0;
	}

	@Override
	public AboutUsHxinfo get(Long id) throws ServiceException {
		return aboutUsHxinfoMapper.selectById(id);
	}
	
	@Override
	public String export(String title,String deputyTitle,String coverImage,String videoUrl,String classify,String content,String details,String language,String status,Date gmtCreate,Date gmtUpdate,Long deleteFlag,Long pid, Integer page, Integer limit)throws ServiceException {
		Wrapper<AboutUsHxinfo> wrapper = new EntityWrapper<AboutUsHxinfo>();
														if (!StringUtils.isEmpty(title)) {
					wrapper.eq("title", title);
				}
												if (!StringUtils.isEmpty(deputyTitle)) {
					wrapper.eq("deputy_title", deputyTitle);
				}
												if (!StringUtils.isEmpty(coverImage)) {
					wrapper.eq("cover_image", coverImage);
				}
												if (!StringUtils.isEmpty(videoUrl)) {
					wrapper.eq("video_url", videoUrl);
				}
												if (!StringUtils.isEmpty(classify)) {
					wrapper.eq("classify", classify);
				}
												if (!StringUtils.isEmpty(content)) {
					wrapper.eq("content", content);
				}
												if (!StringUtils.isEmpty(details)) {
					wrapper.eq("details", details);
				}
												if (!StringUtils.isEmpty(language)) {
					wrapper.eq("language", language);
				}
												if (!StringUtils.isEmpty(status)) {
					wrapper.eq("status", status);
				}
												if (!StringUtils.isEmpty(gmtCreate)) {
					wrapper.eq("gmt_create", gmtCreate);
				}
												if (!StringUtils.isEmpty(gmtUpdate)) {
					wrapper.eq("gmt_update", gmtUpdate);
				}
												if (!StringUtils.isEmpty(deleteFlag)) {
					wrapper.eq("delete_flag", deleteFlag);
				}
												if (!StringUtils.isEmpty(pid)) {
					wrapper.eq("pid", pid);
				}
							List<AboutUsHxinfo> list = aboutUsHxinfoMapper.selectList(wrapper);
		ExcelUtil<AboutUsHxinfo> util = new ExcelUtil<AboutUsHxinfo>(AboutUsHxinfo.class);
		return util.exportExcel(list, "操作日志");
	}
}
